# FLUX.3 Klein API

> แปลงข้อความเป็นภาพด้วยขนาด 4K แบบเนทีฟ ควบคุมเลย์เอาต์ด้วยกรอบขอบเขตได้ และสร้างภาพได้สูงสุด 4 ภาพต่อคำขอ

สร้างภาพจาก `prompt` ข้อความโดยละเอียด แต่ละด้านของ `image_size` อยู่ในช่วง 256 ถึง 4096 พิกเซล และสามารถขอภาพได้ 1 ถึง 4 ภาพต่อการเรียกใช้ `bounding_boxes` สูงสุด 32 รายการช่วยวางวัตถุที่มีชื่อไว้ในตำแหน่งที่กำหนดภายในเฟรม ผลลัพธ์เป็น png, jpeg หรือ webp และสามารถเปิดหรือปิดการขยายพรอมป์ต์ได้

- Model id: `blackforestlabs/flux-3/klein/text-to-image`
- Made by: Black Forest Labs
- Category: Text to Image
- Output: image
- Price per run: from $0.008 / run of output image (cheapest run $0.008 (8 API credits))
- Run: `POST https://api.doitong.ru/v1/run/blackforestlabs/flux-3/klein/text-to-image`
- Quote: `POST https://api.doitong.ru/v1/quote/blackforestlabs/flux-3/klein/text-to-image`
- Docs page: https://doitong.com/th/developers/models/blackforestlabs/flux-3/klein/text-to-image

## Pricing

Price: **from $0.008 / run of output image** (the lowest tier; the quote prices your exact input). Price per run: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.009 = 9 API credits (1 run × $0.009).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/blackforestlabs/flux-3/klein/text-to-image` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  |  | คำแนะนำการสร้างรูปภาพที่อธิบายตัวแบบ การจัดเฟรม แสง และพื้นหลังโดยละเอียด โดยสอดคล้องกับคำบรรยายโดยละเอียดที่ใช้ฝึกโมเดล |
| `enable_prompt_expansion` |  | boolean | no | `true` |  | การขยายพรอมต์เป็นคำบรรยายโดยละเอียดก่อนการสร้าง เปิดใช้เมื่อเป็น true สำหรับการแก้ไข คำบรรยายจะอ้างอิงจากรูปภาพอ้างอิง |
| `seed` |  | integer \| null | no |  |  | Seed สำหรับสร้างรูปภาพซ้ำได้: พรอมต์และ seed เดียวกันจะให้รูปภาพเดียวกันเมื่อเวอร์ชันโมเดลไม่เปลี่ยนแปลง |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | จำนวนรูปภาพที่ขอให้สร้าง |
| `enable_safety_checker` |  | boolean | no | `true` |  | การเปิดใช้ตัวตรวจสอบความปลอดภัย; true จะเปิดใช้การตรวจสอบ |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | รูปแบบไฟล์ของรูปภาพผลลัพธ์ |
| `image_size` |  | object {width, height} \| enum (string) | no | `square_hd` | `square_hd`, `square`, `portrait_4_3`, `portrait_16_9`, `landscape_4_3`, `landscape_16_9` | กำหนดความกว้างและความสูงของเอาต์พุตแยกจากกันภายในช่วง 256–4096 พิกเซล พร้อมรองรับการสร้างแบบ 4K ดั้งเดิม |
| `bounding_boxes` |  | array of object {label, description, box} \| null | no |  | ≤ 32 items | เค้าโครงแบบมีกล่องเสริมที่จำกัดวัตถุแต่ละรายการตามกล่องที่กำหนด ระบุกล่องผ่านป้ายกำกับในพรอมต์ เช่น `A red fox <fox> sits under a red umbrella <umbrella>` พิกัดแสดงขอบกล่องเป็นสัดส่วนของขนาดรูปภาพ โดยวัดจากจุดเริ่มต้นมุมซ้ายบน (0, 0) |
| `bounding_boxes[].label` |  | string \| null | no |  | ≤ 64 characters | ป้ายกำกับสั้น ๆ ของวัตถุสำหรับกล่อง เช่น `fox`; ค่าเริ่มต้นคือ `obj_<n>` ใส่ `<fox>` ในพรอมต์เพื่อเชื่อมโยงคำกับกล่อง กล่องที่ไม่ได้กล่าวถึงในพรอมต์จะถูกเพิ่มลงในฉาก |
| `bounding_boxes[].description` |  | string | yes |  | ≤ 500 characters | วัตถุที่จะเรนเดอร์ภายในกล่อง รวมถึงลักษณะที่ปรากฏ |
| `bounding_boxes[].box` |  | object {x_min, y_min, x_max, y_max} | yes |  |  | ตำแหน่งวัตถุภายในรูปภาพเอาต์พุต |
| `bounding_boxes[].box.x_min` |  | number | yes |  | 0 – 1 | ขอบเขตด้านซ้ายที่แสดงเป็นสัดส่วนเมื่อเทียบกับความกว้างของรูปภาพ ตั้งแต่ 0 ถึง 1 |
| `bounding_boxes[].box.y_min` |  | number | yes |  | 0 – 1 | ขอบเขตด้านบนที่แสดงเป็นสัดส่วนเมื่อเทียบกับความสูงของรูปภาพ ตั้งแต่ 0 ถึง 1 |
| `bounding_boxes[].box.x_max` |  | number | yes |  | 0 – 1 | ขอบเขตด้านขวาที่แสดงเป็นสัดส่วนเมื่อเทียบกับความกว้างของรูปภาพ ตั้งแต่ 0 ถึง 1 |
| `bounding_boxes[].box.y_max` |  | number | yes |  | 0 – 1 | ขอบเขตด้านล่างที่แสดงเป็นสัดส่วนเมื่อเทียบกับความสูงของรูปภาพ ตั้งแต่ 0 ถึง 1 |

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/blackforestlabs/flux-3/klein/text-to-image?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/blackforestlabs/flux-3/klein/text-to-image?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/blackforestlabs/flux-3/klein/text-to-image", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "blackforestlabs/flux-3/klein/text-to-image",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "blackforestlabs/flux-3/klein/text-to-image",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 9,
    "usd": "0.009",
    "charged": 9,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "timings": {},
    "seed": 42,
    "has_nsfw_concepts": [
      false
    ],
    "prompt": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | รูปภาพที่โมเดลสร้าง |
| `timings` | object | ข้อมูลเวลาในการดำเนินการสร้าง |
| `seed` | integer | Seed การสร้างสำหรับรูปภาพแรก |
| `has_nsfw_concepts` | array of boolean | ระบุว่ามีแนวคิด NSFW ปรากฏในรูปภาพที่สร้างหรือไม่ |
| `prompt` | string | พรอมต์ที่ใช้ระหว่างการสร้างรูปภาพ |

## Related models

- [FLUX.3 Klein Image Editing](https://doitong.com/developers/models/blackforestlabs/flux-3/klein/edit-image.md) (`blackforestlabs/flux-3/klein/edit-image`): from $0.008 / run of output image
- [FLUX.1 \[dev\]](https://doitong.com/developers/models/flux/dev.md) (`flux/dev`): $0.025 / megapixel
- [FLUX.1 \[schnell\]](https://doitong.com/developers/models/flux/schnell.md) (`flux/schnell`): $0.003 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image
- [GPT Image 2.5 Text to Image](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/text-to-image.md) (`openai/gpt-image-2.5/flare/text-to-image`): from $0.008 / image
- [Ideogram V4.5](https://doitong.com/developers/models/ideogram/v4.5.md) (`ideogram/v4.5`): from $0.03 / image
- [Nano Banana 2](https://doitong.com/developers/models/nano-banana-2.md) (`nano-banana-2`): from $0.06 / image

## Links

- HTML page: https://doitong.com/developers/models/blackforestlabs/flux-3/klein/text-to-image
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=blackforestlabs/flux-3/klein/text-to-image
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/blackforestlabs/flux-3/klein/text-to-image
